structure Generated =
struct

datatype nat = zero | Suc of nat;

fun less_eq_def0 zero n = true
  | less_eq_def0 (Suc m) n = less_def0 m n
and less_def0 n zero = false
  | less_def0 m (Suc n) = less_eq_def0 m n;

datatype tree = Tip | Nd of tree * nat * tree;

fun memb e Tip = false
  | memb e (Nd (t1, x, t2)) =
    (if less_def0 e x then memb e t1
      else (if less_def0 x e then memb e t2 else true));

fun rm (Nd (l, x, r)) = (if (r = Tip) then x else rm r);

fun rem (Nd (l, x, r)) = (if (r = Tip) then l else Nd (l, x, rem r));

fun remove x Tip = Tip
  | remove x (Nd (l, y, r)) =
    (if less_def0 x y then Nd (remove x l, y, r)
      else (if less_def0 y x then Nd (l, y, remove x r)
             else (if (l = Tip) then r else Nd (rem l, rm l, r))));

fun binsert x Tip = Nd (Tip, x, Tip)
  | binsert x (Nd (t1, y, t2)) =
    (if less_def0 x y then Nd (binsert x t1, y, t2)
      else (if less_def0 y x then Nd (t1, y, binsert x t2)
             else Nd (t1, y, t2)));

fun minus_int x = (fn w => (x + ~ w));

fun minus_def1 x = minus_int x;

fun nat_aux i n = (if (i <= 0) then n else nat_aux (minus_def1 i 1) (Suc n));

fun nat i = nat_aux i zero;

fun number_of_nat x = nat (x);

fun number_of_def1 x = number_of_nat x;

val test =
  memb (number_of_def1 4)
    (remove (number_of_def1 3)
      (binsert (number_of_def1 4) (binsert (number_of_def1 3) Tip)));

end;
